//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Red
#property indicator_color2     LimeGreen
#property indicator_levelstyle STYLE_DASHDOTDOT
#property indicator_levelcolor Gold

//
//
//
//
//

extern double BullBearPeriod  = 100;
extern int    BullBearPrice   = 5;

//
//
//
//
//

double bears[];
double bulls[];
double nlm[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(4);   
   SetIndexBuffer(0,bears);
   SetIndexBuffer(1,bulls);
   SetIndexBuffer(2,nlm);
   SetIndexBuffer(3,trend);
   SetLevelValue(0,0);
   
   IndicatorShortName("NonLag BullsBears ("+DoubleToStr(BullBearPeriod,2)+")");
return(0);
}

//
//
//
//
//

int deinit()
{
      
return(0); 
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
     for (i=limit; i>=0; i--)
     {
        nlm[i]   = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,BullBearPrice,i),BullBearPeriod,i,0);
        bears[i] = nlm[i]  - Low[i];
        bulls[i] = High[i] - nlm[i];
        trend[i] = trend[i+1];
           if (bulls[i] > bears[i]) trend[i] = 1;
           if (bulls[i] < bears[i]) trend[i] =-1;
      
     }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

double  nlm.values[3][1];
double  nlm.prices[ ][1];
double  nlm.alphas[ ][1];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   r = Bars-r-1;
   if (ArrayRange(nlm.prices,0) != Bars) ArrayResize(nlm.prices,Bars);
                               nlm.prices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlm.prices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_length][instanceNo] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlm.values[_length][instanceNo] = length;
         nlm.values[_len   ][instanceNo] = length*4 + Phase;  
         nlm.values[_weight][instanceNo] = 0;

         if (ArrayRange(nlm.alphas,0) < nlm.values[_len][instanceNo]) ArrayResize(nlm.alphas,nlm.values[_len][instanceNo]);
         for (int k=0; k<nlm.values[_len][instanceNo]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlm.alphas[k][instanceNo]        = g * beta;
            nlm.values[_weight][instanceNo] += nlm.alphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_weight][instanceNo]>0)
   {
      double sum = 0;
           for (k=0; k < nlm.values[_len][instanceNo]; k++) sum += nlm.alphas[k][instanceNo]*nlm.prices[r-k][instanceNo];
           return( sum / nlm.values[_weight][instanceNo]);
   }
   else return(0);           
}


